## process-cpp 1.0.0+14.04.20140328

=== CMakeLists.txt ===
# Copyright © 2013 Canonical Ltd.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 3 as
# published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# Authored by: Thomas Voss <thomas.voss@canonical.com>

cmake_minimum_required(VERSION 2.8)

project(process-cpp)

find_package(Boost COMPONENTS iostreams system REQUIRED)
find_package(PkgConfig REQUIRED)
find_package(Threads REQUIRED)

pkg_check_modules(PROPERTIES_CPP properties-cpp)

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake)

include(GNUInstallDirs)

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -pedantic -Wextra -fvisibility=hidden")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11 -Wall -fno-strict-aliasing -fvisibility=hidden -fvisibility-inlines-hidden -pedantic -Wextra")
set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,--no-undefined")

option(PROCESS_CPP_WERROR "Treat warnings as errors" ON)

if(PROCESS_CPP_WERROR)
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Werror -Wno-error=format")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Werror -Wno-error=format")
endif(PROCESS_CPP_WERROR)

string(TOLOWER "${CMAKE_BUILD_TYPE}" cmake_build_type_lower)

#####################################################################
# Enable code coverage calculation with gcov/gcovr/lcov
# Usage:
#  * Switch build type to coverage (use ccmake or cmake-gui)
#  * Invoke make, make test, make coverage
#  * Find html report in subdir coveragereport
#  * Find xml report feasible for jenkins in coverage.xml
#####################################################################
IF(cmake_build_type_lower MATCHES coverage)
  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -ftest-coverage -fprofile-arcs" )
  SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -ftest-coverage -fprofile-arcs" )
  SET(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -ftest-coverage -fprofile-arcs" )
  SET(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -ftest-coverage -fprofile-arcs" )
ENDIF(cmake_build_type_lower MATCHES coverage)

set(PROCESS_CPP_VERSION_MAJOR 1)
set(PROCESS_CPP_VERSION_MINOR 0)
set(PROCESS_CPP_VERSION_PATCH 0)

include(CTest)

include_directories(
  include/

  ${Boost_INCLUDE_DIRS}
  ${PROPERTIES_CPP_INCLUDE_DIRS}
)

add_subdirectory(doc)
add_subdirectory(data)
add_subdirectory(include)
add_subdirectory(src)
add_subdirectory(tests)

## process-cpp 2.0.0+14.10.20140718

=== CMakeLists.txt ===
--- 
+++ 
@@ -56,7 +56,7 @@
   SET(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -ftest-coverage -fprofile-arcs" )
 ENDIF(cmake_build_type_lower MATCHES coverage)
 
-set(PROCESS_CPP_VERSION_MAJOR 1)
+set(PROCESS_CPP_VERSION_MAJOR 2)
 set(PROCESS_CPP_VERSION_MINOR 0)
 set(PROCESS_CPP_VERSION_PATCH 0)

## process-cpp 3.0.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -56,7 +56,7 @@
   SET(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -ftest-coverage -fprofile-arcs" )
 ENDIF(cmake_build_type_lower MATCHES coverage)
 
-set(PROCESS_CPP_VERSION_MAJOR 2)
+set(PROCESS_CPP_VERSION_MAJOR 3)
 set(PROCESS_CPP_VERSION_MINOR 0)
 set(PROCESS_CPP_VERSION_PATCH 0)

=== data/CMakeLists.txt ===
# Copyright © 2013 Canonical Ltd.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 3 as
# published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# Authored by: Thomas Voss <thomas.voss@canonical.com>

configure_file(
  process-cpp.pc.in process-cpp.pc @ONLY
)

install(
  FILES ${CMAKE_CURRENT_BINARY_DIR}/process-cpp.pc
  DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig
)

=== doc/CMakeLists.txt ===
# Copyright © 2013 Canonical Ltd.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 3 as
# published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# Authored by: Thomas Voss <thomas.voss@canonical.com>

option(
  PROCESS_CPP_ENABLE_DOC_GENERATION
  "Generate package documentation with doxygen"
  ON
)

string(TOLOWER "${CMAKE_BUILD_TYPE}" cmake_build_type_lower)

if("${cmake_build_type_lower}" STREQUAL "debug")
  option(
    PROCESS_CPP_ENABLE_DOC_GENERATION_BY_DEFAULT
    "Generate package by default"
    OFF
  )
else()
  option(
    PROCESS_CPP_ENABLE_DOC_GENERATION_BY_DEFAULT
    "Generate package by default"
    ON
  )
endif()

if (PROCESS_CPP_ENABLE_DOC_GENERATION)

if (${PROCESS_CPP_ENABLE_DOC_GENERATION_BY_DEFAULT})
  set (IS_ALL ALL)
endif ()

find_package(Doxygen)

if (DOXYGEN_FOUND)
  configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in 
    ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile @ONLY)
  add_custom_target(doc ${IS_ALL}
    ${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
    COMMENT "Generating API documentation with Doxygen" VERBATIM)
  install(
    DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/html
    DESTINATION ${CMAKE_INSTALL_DOCDIR})
endif (DOXYGEN_FOUND)
endif (PROCESS_CPP_ENABLE_DOC_GENERATION)

=== include/CMakeLists.txt ===
# Copyright © 2013 Canonical Ltd.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 3 as
# published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# Authored by: Thomas Voss <thomas.voss@canonical.com>

install(
  DIRECTORY core
  DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/
)

=== src/CMakeLists.txt ===
# Copyright © 2013 Canonical Ltd.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 3 as
# published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# Authored by: Thomas Voss <thomas.voss@canonical.com>

add_library(
  process-cpp SHARED
  
  core/posix/backtrace.h
  core/posix/backtrace.cpp

  core/posix/child_process.cpp
  core/posix/exec.cpp
  core/posix/fork.cpp
  core/posix/process.cpp
  core/posix/process_group.cpp
  core/posix/signal.cpp
  core/posix/signalable.cpp
  core/posix/standard_stream.cpp
  core/posix/wait.cpp
  core/posix/this_process.cpp

  core/posix/linux/proc/process/oom_adj.cpp
  core/posix/linux/proc/process/oom_score.cpp
  core/posix/linux/proc/process/oom_score_adj.cpp
  core/posix/linux/proc/process/stat.cpp

  core/testing/cross_process_sync.cpp
  core/testing/fork_and_run.cpp
)

target_link_libraries(
  process-cpp

  ${Boost_LIBRARIES}
  ${CMAKE_THREAD_LIBS_INIT}
)

# We compile with all symbols visible by default. For the shipping library, we strip
# out all symbols that are not in core::*
set(symbol_map "${CMAKE_SOURCE_DIR}/symbols.map")
set_target_properties(
  process-cpp

  PROPERTIES
  LINK_FLAGS "${ldflags} -Wl,--version-script,${symbol_map}"
  LINK_DEPENDS ${symbol_map}
  VERSION ${PROCESS_CPP_VERSION_MAJOR}.${PROCESS_CPP_VERSION_MINOR}.${PROCESS_CPP_VERSION_PATCH}
  SOVERSION ${PROCESS_CPP_VERSION_MAJOR}
)

install(
  TARGETS process-cpp
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
)

=== tests/CMakeLists.txt ===
# Copyright © 2013 Canonical Ltd.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 3 as
# published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# Authored by: Thomas Voss <thomas.voss@canonical.com>

# Build with system gmock and embedded gtest
set (GMOCK_INCLUDE_DIR "/usr/include/gmock/include" CACHE PATH "gmock source include directory")
set (GMOCK_SOURCE_DIR "/usr/src/gmock" CACHE PATH "gmock source directory")
set (GTEST_INCLUDE_DIR "${GMOCK_SOURCE_DIR}/gtest/include" CACHE PATH "gtest source include directory")
set (GMOCK_BOTH_LIBRARIES gmock gmock_main)
add_subdirectory(${GMOCK_SOURCE_DIR} "${CMAKE_CURRENT_BINARY_DIR}/gmock")

#set (OLD_CMAKE_CXX_FLAGS ${CMAKE_CXX_FLAGS})
# Don't treat warnings as errors in 3rd_party/{gmock,cucumber-cpp}
#string (REPLACE " -Werror " " " CMAKE_CXX_FLAGS ${CMAKE_CXX_FLAGS})
#find_package(Gtest REQUIRED)
include_directories(${GMOCK_INCLUDE_DIR} ${GTEST_INCLUDE_DIR})
#set (CMAKE_CXX_FLAGS ${OLD_CMAKE_CXX_FLAGS})

include_directories(
  ${CMAKE_SOURCE_DIR}/src
  ${GTEST_INCLUDE_DIR}
)

add_executable(
  posix_process_test
  posix_process_test.cpp
)

add_executable(
  linux_process_test
  linux_process_test.cpp
)

add_executable(
  fork_and_run_test
  fork_and_run_test.cpp

  # We include an external source file to prevent from leaking
  # symbols to the outside world
  ${CMAKE_SOURCE_DIR}/src/core/posix/backtrace.cpp
)

add_executable(
  cross_process_sync_test
  cross_process_sync_test.cpp
)

add_executable(
  death_observer_test
  death_observer_test.cpp
)

target_link_libraries(
  posix_process_test

  process-cpp

  ${CMAKE_THREAD_LIBS_INIT}
  ${GMOCK_BOTH_LIBRARIES}
)

target_link_libraries(
  linux_process_test

  process-cpp

  ${CMAKE_THREAD_LIBS_INIT}
  ${GMOCK_BOTH_LIBRARIES}
)

target_link_libraries(
  fork_and_run_test

  process-cpp

  ${CMAKE_THREAD_LIBS_INIT}
  ${GMOCK_BOTH_LIBRARIES}
)

target_link_libraries(
  cross_process_sync_test

  process-cpp

  ${CMAKE_THREAD_LIBS_INIT}
  ${GMOCK_BOTH_LIBRARIES}
)

target_link_libraries(
  death_observer_test

  process-cpp

  ${CMAKE_THREAD_LIBS_INIT}
  ${GMOCK_BOTH_LIBRARIES}
)

add_test(posix_process_test ${CMAKE_CURRENT_BINARY_DIR}/posix_process_test)
add_test(linux_process_test ${CMAKE_CURRENT_BINARY_DIR}/linux_process_test)
add_test(fork_and_run_test ${CMAKE_CURRENT_BINARY_DIR}/fork_and_run_test)
add_test(cross_process_sync_test ${CMAKE_CURRENT_BINARY_DIR}/cross_process_sync_test)
add_test(death_observer_test ${CMAKE_CURRENT_BINARY_DIR}/death_observer_test)

=== src/core/posix/CMakeLists.txt ===
# Copyright © 2013 Canonical Ltd.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 3 as
# published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# Authored by: Thomas Voss <thomas.voss@canonical.com>

add_library(
  posix-process

  process.cpp
)

add_subdirectory(linux)

=== debian/changelog ===
process-cpp (3.0.1-9) unstable; urgency=medium

  [ Mike Gabriel ]
  * debian/changelog:
    + post-upload give credits to Chris Lamb for the patch regarding #961202.
  * debian/control:
    + Add Rules-Requires-Root: field and set it to 'no'.
    + Bump Standards-Version: to 4.6.0. No changes needed.
    + Add B-Ds: rdfind, symbols.
  * debian/*.lintian-overrides:
    + Drop files. Not required anymore.
  * debian/{rules,libprocess-cpp-doc.install}:
    + Move doc files into doc:pkg's doc folder.
  * debian/rules:
    + Enable all hardening build flags.
    + Clean-up duplicate files in API docs and use symlinks instead.
  * debian/patches:
    + Add 1004-spelling-fixes.patch. Fix spelling of the word 'occurred'.
      Thanks, lintian.
    + Rename patch files to match our patch naming scheme.

  [ Aurelien Jarno ]
  * debian/patches:
    + Add 0003-link-pthread.patch. Fix FTBFS on riscv64, link with -lpthread
      instead of -pthread. (Closes: 1002052).

 -- Mike Gabriel <sunweaver@debian.org>  Tue, 21 Dec 2021 08:35:29 +0100

process-cpp (3.0.1-8) unstable; urgency=medium

  * debian/patches:
    + Improve 0002-Reproducible-documentation.patch. Exclude link.txt from documentation.
      This makes the build (even more) reproducible. (Closes: #961202). Thanks to
      Chris Lamb for the patch.
  * debian/control:
    + Bump DH compat level to version 13.
    + Bump Standards-Version: to 4.5.0. No changes needed.
  * debian/rules:
    + Add EOL at EOF.

 -- Mike Gabriel <sunweaver@debian.org>  Sun, 18 Oct 2020 20:12:34 +0200

process-cpp (3.0.1-7) unstable; urgency=medium

  * debian/control:
    + Update Vcs-*: fields in accordance to new maintenance team.
  * debian/upstream/metadata:
    + Add file. Comply with DEP-12.
  * debian/patches/README:
    + Add README explaining our patch naming scheme.
  * debian/rules:
    + Add get-orig-source target.
  * debian/libprocess-cpp3.symbols:
    + Add Build-Depends-Package: metadata field.

 -- Mike Gabriel <sunweaver@debian.org>  Sat, 26 Sep 2020 23:54:15 +0200

process-cpp (3.0.1-6) unstable; urgency=medium

  * debian/control:
    + Adopt package. Move over to Debian UBports Team. (Closes: #904425).
    + Bump Standards-Version: to 4.4.1. No changes needed.
    + Restrict this package to linux-any architecture. (Closes: #889000).
  * debian/{control,compat}:
    + Switch to debhelper-compat notation. Bump to DH compat level version 12.
  * debian/{control,copyright}:
    + Update Homepage: (and Source:) field. New upstream is the UBports project.
  * debian/watch:
    + Add watch file.
  * debian/gbp.conf:
    + Drop file; switch to gbp's defaults.
  * debian/copyright:
    + Update copyright attributions.

 -- Mike Gabriel <sunweaver@debian.org>  Sat, 25 Jan 2020 15:18:35 +0100

process-cpp (3.0.1-5) unstable; urgency=medium

  * Orphan package.
  * Update Vcs-* headers to point to salsa.
  * Bump Standards-Version to 4.1.5.

 -- Chris Lamb <lamby@debian.org>  Tue, 24 Jul 2018 16:28:18 +0800

process-cpp (3.0.1-4) unstable; urgency=medium

  * Correct Vcs-Bzr -> Vcs-Git.

 -- Chris Lamb <lamby@debian.org>  Sat, 17 Feb 2018 22:45:20 +0000

process-cpp (3.0.1-3) unstable; urgency=medium

  * Make the documentation reproducible.

 -- Chris Lamb <lamby@debian.org>  Thu, 01 Feb 2018 10:15:27 +0000

process-cpp (3.0.1-2) unstable; urgency=medium

  * Update symbols files to fix FTBFS on mips64el and non-release 64bit
    architectures due symbol differences. (Closes: #888724)

 -- Chris Lamb <lamby@debian.org>  Mon, 29 Jan 2018 16:52:14 +0000

process-cpp (3.0.1-1) unstable; urgency=medium

  * Upload to / fork for Debian unstable. (Closes: #887961)

 -- Chris Lamb <lamby@debian.org>  Sun, 21 Jan 2018 17:36:45 +1100

process-cpp (3.0.1-0ubuntu5) zesty; urgency=high

  * No change rebuild against boost1.62.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 01 Nov 2016 16:39:24 +0000

process-cpp (3.0.1-0ubuntu4) yakkety; urgency=medium

  * No-change rebuild for boost soname change.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 04 Aug 2016 08:30:21 +0000

process-cpp (3.0.1-0ubuntu3) yakkety; urgency=medium

  * No-change rebuild for boost soname change.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 23 Apr 2016 18:48:36 +0000

process-cpp (3.0.1-0ubuntu2) xenial; urgency=medium

  * Fix symbols file for s390x.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 30 Nov 2015 23:06:31 +0000

process-cpp (3.0.1-0ubuntu1) wily; urgency=medium

  * Bump version.

 -- Thomas Voß <thomas.voss@canonical.com>  Tue, 21 Jul 2015 11:45:34 +0200

process-cpp (3.0.0) wily; urgency=medium

  * Bump major revision and so name to account for toolchain update.

 -- Thomas Voß <thomas.voss@canonical.com>  Mon, 20 Jul 2015 20:39:56 +0200

process-cpp (2.0.0+14.10.20140718-0ubuntu1) utopic; urgency=medium

  [ Thomas Voß ]
  * Bump major revision and so name to account for toolchain update.

 -- Ubuntu daily release <ps-jenkins@lists.canonical.com>  Fri, 18 Jul 2014 12:29:36 +0000

process-cpp (1.0.1+14.10.20140522-0ubuntu1) utopic; urgency=medium

  [ Pete Woods ]
  * Add child_setup function to core::posic::exec.

  [ Ubuntu daily release ]
  * debian/*symbols: auto-update new symbols to released version
  * New rebuild forced

 -- Ubuntu daily release <ps-jenkins@lists.canonical.com>  Thu, 22 May 2014 09:49:51 +0000

process-cpp (1.0.0+14.04.20140328-0ubuntu2) utopic; urgency=high

  * No change rebuild against boost1.55.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Sun, 27 Apr 2014 02:37:06 +0100

process-cpp (1.0.0+14.04.20140328-0ubuntu1) trusty; urgency=low

  [ Marcus Tomlinson ]
  * Split environment variable at first occurrence of '=' rather than
    splitting at every '=' (causes issues when a value contains an '=')

 -- Ubuntu daily release <ps-jenkins@lists.canonical.com>  Fri, 28 Mar 2014 09:40:37 +0000

process-cpp (1.0.0+14.04.20140326.2-0ubuntu1) trusty; urgency=medium

  [ Thomas Voß ]
  * Bump so name.
  * Fix death observer racyness.


=== debian/control ===
Source: process-cpp
Priority: optional
Maintainer: Debian UBports Team <team+ubports@tracker.debian.org>
Uploaders:
 Mike Gabriel <sunweaver@debian.org>,
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 doxygen,
 graphviz,
 libboost-dev,
 libboost-iostreams-dev,
 libboost-system-dev,
 libproperties-cpp-dev,
 pkg-config,
 rdfind,
 symlinks,
Standards-Version: 4.6.0
Rules-Requires-Root: no
Section: libs
Homepage: https://gitlab.com/ubports/core/lib-cpp/process-cpp
Vcs-Git: https://salsa.debian.org/ubports-team/process-cpp.git
Vcs-Browser: https://salsa.debian.org/ubports-team/process-cpp

Package: libprocess-cpp3
Architecture: linux-any
Multi-Arch: same
Pre-Depends:
 ${misc:Pre-Depends}
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Description: C++11 library for handling processes (runtime libraries)
 process-cpp is a simple and straightforward wrapper around process creation
 and control. It helps both with handling child processes and with interacting
 with the current process. Some of its features include:
 .
  - Thread-safe get/set/unset operation on the current process's environment.
  - Throwing and non-throwing overloads of functions when system calls are
    involved.
  - Seamless redirection of input, output and error streams of child processes.
  - Type-safe interaction with the virtual proc filesystem, both for reading &
    writing.
 .
 The library's main purpose is to assist in testing and when a software
 component needs to carry out process creation/control tasks, e.g., a graphical
 shell. To this end, the library is extensively tested and tries to ensure
 fail-safe operation as much as possible.
 .
 This package includes the process-cpp runtime libraries.

Package: libprocess-cpp-dev
Section: libdevel
Architecture: linux-any
Multi-Arch: same
Recommends:
 libprocess-cpp-doc
Depends:
 libprocess-cpp3 (= ${binary:Version}),
 libproperties-cpp-dev,
 ${misc:Depends}
Description: C++11 library for handling processes (dev headers and libraries)
 process-cpp is a simple and straightforward wrapper around process creation
 and control. It helps both with handling child processes and with interacting
 with the current process. Some of its features include:
 .
  - Thread-safe get/set/unset operation on the current process's environment.
  - Throwing and non-throwing overloads of functions when system calls are
    involved.
  - Seamless redirection of input, output and error streams of child processes.
  - Type-safe interaction with the virtual proc filesystem, both for reading &
    writing.
 .
 This package includes all the development headers and libraries for
 process-cpp.

Package: libprocess-cpp-doc
Section: doc
Architecture: all
Depends:
 ${misc:Depends}
Suggests:
 libprocess-cpp-dev
Description: C++11 library for handling processes (documentation)
 process-cpp is a simple and straightforward wrapper around process creation
 and control. It helps both with handling child processes and with interacting
 with the current process. Some of its features include:
 .
  - Thread-safe get/set/unset operation on the current process's environment.
  - Throwing and non-throwing overloads of functions when system calls are
    involved.
  - Seamless redirection of input, output and error streams of child processes.
  - Type-safe interaction with the virtual proc filesystem, both for reading &
    writing.
 .
 This package includes documentation files for the libprocess-cpp development.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

%:
	dh $@

override_dh_install:
	mkdir -p debian/tmp/usr/share/doc/libprocess-cpp-doc/
	mv debian/tmp/usr/share/doc/process-cpp/html debian/tmp/usr/share/doc/libprocess-cpp-doc/
	rmdir debian/tmp/usr/share/doc/process-cpp/

	# remove duplicate files and symlink them instead
	rdfind -makesymlinks true "debian/tmp/usr/share/doc/libprocess-cpp-doc/"
	symlinks -rc "debian/tmp/usr/share/doc/libprocess-cpp-doc/"

	dh_install

get-orig-source:
	uscan --noconf --force-download --rename --download-current-version --destdir=.

=== debian/watch ===
version=4
https://gitlab.com/ubports/core/lib-cpp/process-cpp/tags .*/process-cpp-(\d\S+)\.tar\.gz

## process-cpp 3.0.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -21,15 +21,18 @@
 find_package(Boost COMPONENTS iostreams system REQUIRED)
 find_package(PkgConfig REQUIRED)
 find_package(Threads REQUIRED)
+find_package(Backtrace)
 
 pkg_check_modules(PROPERTIES_CPP properties-cpp)
 
-set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake)
-
 include(GNUInstallDirs)
 
+set(CMAKE_CXX_STANDARD 17)
+set(CMAKE_CXX_EXTENSIONS OFF)
+set(CMAKE_CXX_STANDARD_REQUIRED ON)
+
 set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -pedantic -Wextra -fvisibility=hidden")
-set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11 -Wall -fno-strict-aliasing -fvisibility=hidden -fvisibility-inlines-hidden -pedantic -Wextra")
+set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -fno-strict-aliasing -fvisibility=hidden -fvisibility-inlines-hidden -pedantic -Wextra")
 set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,--no-undefined")
 
 option(PROCESS_CPP_WERROR "Treat warnings as errors" ON)
@@ -73,4 +76,7 @@
 add_subdirectory(data)
 add_subdirectory(include)
 add_subdirectory(src)
-add_subdirectory(tests)
+
+if (BUILD_TESTING)
+  add_subdirectory(tests)
+endif ()

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -45,6 +45,7 @@
 
   ${Boost_LIBRARIES}
   ${CMAKE_THREAD_LIBS_INIT}
+  ${Backtrace_LIBRARIES}
 )
 
 # We compile with all symbols visible by default. For the shipping library, we strip

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -14,23 +14,12 @@
 #
 # Authored by: Thomas Voss <thomas.voss@canonical.com>
 
-# Build with system gmock and embedded gtest
-set (GMOCK_INCLUDE_DIR "/usr/include/gmock/include" CACHE PATH "gmock source include directory")
-set (GMOCK_SOURCE_DIR "/usr/src/gmock" CACHE PATH "gmock source directory")
-set (GTEST_INCLUDE_DIR "${GMOCK_SOURCE_DIR}/gtest/include" CACHE PATH "gtest source include directory")
-set (GMOCK_BOTH_LIBRARIES gmock gmock_main)
-add_subdirectory(${GMOCK_SOURCE_DIR} "${CMAKE_CURRENT_BINARY_DIR}/gmock")
-
-#set (OLD_CMAKE_CXX_FLAGS ${CMAKE_CXX_FLAGS})
-# Don't treat warnings as errors in 3rd_party/{gmock,cucumber-cpp}
-#string (REPLACE " -Werror " " " CMAKE_CXX_FLAGS ${CMAKE_CXX_FLAGS})
-#find_package(Gtest REQUIRED)
-include_directories(${GMOCK_INCLUDE_DIR} ${GTEST_INCLUDE_DIR})
-#set (CMAKE_CXX_FLAGS ${OLD_CMAKE_CXX_FLAGS})
+find_package(GMock)
 
 include_directories(
   ${CMAKE_SOURCE_DIR}/src
   ${GTEST_INCLUDE_DIR}
+  ${GMOCK_INCLUDE_DIR}
 )
 
 add_executable(
@@ -68,7 +57,7 @@
   process-cpp
 
   ${CMAKE_THREAD_LIBS_INIT}
-  ${GMOCK_BOTH_LIBRARIES}
+  ${GMOCK_LIBRARIES}
 )
 
 target_link_libraries(
@@ -77,7 +66,7 @@
   process-cpp
 
   ${CMAKE_THREAD_LIBS_INIT}
-  ${GMOCK_BOTH_LIBRARIES}
+  ${GMOCK_LIBRARIES}
 )
 
 target_link_libraries(
@@ -86,7 +75,7 @@
   process-cpp
 
   ${CMAKE_THREAD_LIBS_INIT}
-  ${GMOCK_BOTH_LIBRARIES}
+  ${GMOCK_LIBRARIES}
 )
 
 target_link_libraries(
@@ -95,7 +84,7 @@
   process-cpp
 
   ${CMAKE_THREAD_LIBS_INIT}
-  ${GMOCK_BOTH_LIBRARIES}
+  ${GMOCK_LIBRARIES}
 )
 
 target_link_libraries(
@@ -104,7 +93,7 @@
   process-cpp
 
   ${CMAKE_THREAD_LIBS_INIT}
-  ${GMOCK_BOTH_LIBRARIES}
+  ${GMOCK_LIBRARIES}
 )
 
 add_test(posix_process_test ${CMAKE_CURRENT_BINARY_DIR}/posix_process_test)

=== debian/changelog ===
process-cpp (3.0.2-1) unstable; urgency=medium

  * New upstream release.
    - Fix wrong SOVERSION of library. Sneaking in a hidden transition.
  * debian/patches:
    + Drop 2001-Don-t-run-tests.patch. Does not apply anymore and we want to
      enable tests with this upload.
    + Trivially rebase 1003-link-pthread.patch and 1004-spelling-fixes.patch.
    + Add 1005_fix-linking-against-gtest.patch. Fix linking of unit tests on
      current Debian testing/unstable.
  * debian/rules:
    + Fix destdir in get-orig-source target's uscan call.
    + Remove results.txt build-cruft during dh_clean override. (Closes:
      #1049137).
  * debian/control:
    + Add B-Ds for running unit tests.
    + Add B-D: cmake-extras (for GMock CMake module).

 -- Mike Gabriel <sunweaver@debian.org>  Fri, 16 Aug 2024 00:08:10 +0200

process-cpp (3.0.1-10) unstable; urgency=medium

  [ Mike Gabriel ]
  * debian/: Update upstream Git repo URL.
  * debian/watch:
    + Update file for recent GitLab changes of the tags overview page.
  * debian/libprocess-cpp3.symbols:
    + Drop file. Causing more woes than being helpful. (Closes: #1076906).
  * debian/control:
    + Bump Standards-Version to 4.7.0. No changes needed.
    + In B-D, switch from pkg-config to pkgconf.

  [ Anton Gladky ]
  * Add debian/.gitlab-ci.yml

 -- Mike Gabriel <sunweaver@debian.org>  Wed, 14 Aug 2024 19:32:18 +0200

=== debian/control ===
--- 
+++ 
@@ -5,20 +5,24 @@
  Mike Gabriel <sunweaver@debian.org>,
 Build-Depends:
  cmake,
+ cmake-extras,
  debhelper-compat (= 13),
  doxygen,
  graphviz,
+ googletest | google-mock,
  libboost-dev,
  libboost-iostreams-dev,
  libboost-system-dev,
+ libgmock-dev,
+ libgtest-dev,
  libproperties-cpp-dev,
- pkg-config,
+ pkgconf,
  rdfind,
  symlinks,
-Standards-Version: 4.6.0
+Standards-Version: 4.7.0
 Rules-Requires-Root: no
 Section: libs
-Homepage: https://gitlab.com/ubports/core/lib-cpp/process-cpp
+Homepage: https://gitlab.com/ubports/development/core/lib-cpp/process-cpp
 Vcs-Git: https://salsa.debian.org/ubports-team/process-cpp.git
 Vcs-Browser: https://salsa.debian.org/ubports-team/process-cpp

=== debian/rules ===
--- 
+++ 
@@ -18,5 +18,9 @@
 
 	dh_install
 
+override_dh_clean:
+	dh_clean
+	rm -f results.txt
+
 get-orig-source:
-	uscan --noconf --force-download --rename --download-current-version --destdir=.
+	uscan --noconf --force-download --rename --download-current-version --destdir=..

## process-cpp 3.0.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -14,12 +14,13 @@
 #
 # Authored by: Thomas Voss <thomas.voss@canonical.com>
 
-cmake_minimum_required(VERSION 2.8)
+cmake_minimum_required(VERSION 3.10)
 
 project(process-cpp)
 
-find_package(Boost COMPONENTS iostreams system REQUIRED)
+find_package(Boost COMPONENTS iostreams REQUIRED)
 find_package(PkgConfig REQUIRED)
+set(THREADS_PREFER_PTHREAD_FLAG ON)
 find_package(Threads REQUIRED)
 find_package(Backtrace)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -16,7 +16,7 @@
 
 add_library(
   process-cpp SHARED
-  
+
   core/posix/backtrace.h
   core/posix/backtrace.cpp
 
@@ -43,8 +43,9 @@
 target_link_libraries(
   process-cpp
 
+  Threads::Threads
+
   ${Boost_LIBRARIES}
-  ${CMAKE_THREAD_LIBS_INIT}
   ${Backtrace_LIBRARIES}
 )

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -56,7 +56,7 @@
 
   process-cpp
 
-  ${CMAKE_THREAD_LIBS_INIT}
+  Threads::Threads
   ${GMOCK_LIBRARIES}
 )
 
@@ -65,7 +65,7 @@
 
   process-cpp
 
-  ${CMAKE_THREAD_LIBS_INIT}
+  Threads::Threads
   ${GMOCK_LIBRARIES}
 )
 
@@ -74,7 +74,7 @@
 
   process-cpp
 
-  ${CMAKE_THREAD_LIBS_INIT}
+  Threads::Threads
   ${GMOCK_LIBRARIES}
 )
 
@@ -83,7 +83,7 @@
 
   process-cpp
 
-  ${CMAKE_THREAD_LIBS_INIT}
+  Threads::Threads
   ${GMOCK_LIBRARIES}
 )
 
@@ -92,7 +92,7 @@
 
   process-cpp
 
-  ${CMAKE_THREAD_LIBS_INIT}
+  Threads::Threads
   ${GMOCK_LIBRARIES}
 )

=== debian/changelog ===
process-cpp (3.0.3-2) unstable; urgency=medium

  * Team upload

  [ Jeremy Bícha ]
  * Remove obsolete Build-Depends: libboost-system-dev (Closes: #1127258)
  * Add minimal debian/gbp.conf
  * Update Standards Version to 4.7.3

  [ Thorsten Alteholz ]
  * Use salsa-ci.yml instead of .gitlab-ci.yml

 -- Jeremy Bícha <jbicha@ubuntu.com>  Fri, 20 Feb 2026 11:18:46 -0500

process-cpp (3.0.3-1) unstable; urgency=medium

  * New upstream release.
  * debian/patches:
    + Drop patches 1002, 1003, 1004, 1006. Applied upstream.
    + Rebase 1005_fix-linking-against-gtest.patch.
  * debian/copyright:
    + Update copyright attributions for debian/.
  * debian/control:
    + Bump Standards-Version: to 4.7.2. No changes needed.

 -- Mike Gabriel <sunweaver@debian.org>  Wed, 03 Dec 2025 10:29:21 +0100

process-cpp (3.0.2-2) unstable; urgency=medium

  * debian/control:
    + Add Multi-Arch: foreign declaration. Thanks, Multi-Arch Hinter.
  * debian/patches:
    + Add 1006_CMakeLists.txt-Bump-cmake_minimum_required-to-versio.patch. Fix
      building with CMake 4. (Closes: #1113422).

 -- Mike Gabriel <sunweaver@debian.org>  Mon, 01 Sep 2025 16:35:43 +0200

=== debian/control ===
--- 
+++ 
@@ -1,5 +1,4 @@
 Source: process-cpp
-Priority: optional
 Maintainer: Debian UBports Team <team+ubports@tracker.debian.org>
 Uploaders:
  Mike Gabriel <sunweaver@debian.org>,
@@ -12,15 +11,13 @@
  googletest | google-mock,
  libboost-dev,
  libboost-iostreams-dev,
- libboost-system-dev,
  libgmock-dev,
  libgtest-dev,
  libproperties-cpp-dev,
  pkgconf,
  rdfind,
  symlinks,
-Standards-Version: 4.7.0
-Rules-Requires-Root: no
+Standards-Version: 4.7.3
 Section: libs
 Homepage: https://gitlab.com/ubports/development/core/lib-cpp/process-cpp
 Vcs-Git: https://salsa.debian.org/ubports-team/process-cpp.git
@@ -81,6 +78,7 @@
 Package: libprocess-cpp-doc
 Section: doc
 Architecture: all
+Multi-Arch: foreign
 Depends:
  ${misc:Depends}
 Suggests:
